#ifndef DRAW_H
#define DRAW_H
#include "config.h"
#include "layout.h"
#include "stage.h"
#include "font.h"

typedef struct {
    int r, g, b;
} rgb_t;

#define SetColor(c) (EzSetColorByRGB(colors[(c)].r, colors[(c)].g, colors[(c)].b))

extern rgb_t colors[];


typedef enum
    {
     ii_invalid = 0,
     ii_begin = 1,

     ii_wall = 1,
     ii_block,
     ii_food,
     ii_player,
     ii_player_food,
     ii_trunk,
     
     ii_end,
    } image_id_t;

typedef enum
    {sr_begin = 0, sr_none=0,
     sr_value_overlap,
     sr_value_only,
     sr_dir_overlap,
     sr_dir_only,
     sr_end
    } show_route_mode_t;

void draw_init(void);
void setup_draw_screen(void);
// グラフィック座標(x, y)にID iidの画像を表示
void draw_img(int x, int y, image_id_t iid);
// マップ座標(x, y)にmeのキャラクタを表示
void draw_map_element(int x, int y, map_element_t me);
void draw_screen(void);
void draw_route_value(int x, int y);
void draw_route_dir(int x, int y);
show_route_mode_t get_show_route_mode(void);
void set_show_route_mode(show_route_mode_t mode);


#endif
