#ifndef ROUTING_H
#define ROUTING_H
#include "config.h"
#include "uty.h"

#define ROUTE_VALUE_MAX 255

typedef unsigned char route_value_t;
typedef signed char route_dir_t;

extern char *dir2chr_str;
#define Dir2Chr(dir) (dir2chr_str[dir+1])

void routing_init(void);
void setup_routing(void);
void set_route_value(int x, int y, unsigned char value);
route_value_t get_route_value(int x, int y);
void set_route_dir(int x, int y, dir_t dir);
dir_t get_route_dir(int x, int y);

void clear_route_stack(void);
void push_route_stack(int x, int y);
int pop_route_stack(int *x, int *y);
int get_reachable_food_num(void);
    
void make_value_map(void);
void make_dir_map(void);


#endif
