#ifndef STAGE_H
#define STAGE_H
#include "config.h"
#include "param.h"

typedef enum {
              me_invalid = -1,
              me_begin = 0,
              me_blank = 0,
              me_wall,
              me_block,
              me_food,
              me_player,
              me_player_food,  // playerとfoodが重なった状態
              me_home, //鼻のルート探索開始位置
              me_trunk,
              me_end,
} map_element_t;


#define SC_STR "tbe"
typedef enum {
              sc_none, sc_title, sc_map_begin, sc_map_end,
} stage_command_t;

#define INVALID_X (-1)
#define INVALID_Y (-1)

typedef struct {
	char *name;
    //	unsigned char major_version;
    //	unsigned char minor_version;
    //	unsigned int no;
    map_element_t map[MAP_HEIGHT][MAP_WIDTH];
    // 以下の値はファイル読み込み時にステージマップから自動検出し設定
    int player_x, player_y;  // プレイヤー初期位置
    int home_x, home_y;      // 鼻の開始位置
	unsigned int food_num;
    //    font_id_t title[STAGE_TITLE_ROW_NUM][STAGE_TITLE_WIDTH+1];
    //    font_id_t description[STAGE_DESCRIPTION_ROW_NUM][STAGE_DESCRIPTION_WIDTH+1];
} stage_t;
              
typedef struct {
    //	font_id_t stars_fontseq[4];
    //    font_id_t title[STAGE_TITLE_ROW_NUM][STAGE_TITLE_WIDTH+1];
    //n	unsigned char major_version;
    //	unsigned char minor_version;
    //	unsigned int top_score;  // 最高得点
    //	unsigned int clear_num;  // クリア回数
    int map[MAP_HEIGHT][MAP_WIDTH];
} stage_thumb_t;

#define GetThumbColor(x, y) (thumb->map[y][x])

void stage_init(char *argv0);
void setup_stage(void);
void clear_stage(void);
void load_stage(char *stage_name);
void get_thumb(char *stage_name, stage_thumb_t *thumb, int stage_no);
map_element_t get_map_element(int x, int y);
void set_map_element(int x, int y, map_element_t me);
void set_stage_player_xy(int x, int y);    
int get_stage_player_x(void);
int get_stage_player_y(void);

int get_stage_home_x(void);
int get_stage_home_y(void);

int get_stage_food_num(void);
//int get_stage_food_x(int id);
//int get_stage_food_y(int id);
void delete_stage_food(int x, int y);
int get_thumb_color(int x, int y);

#endif
