#include <stdio.h>
#include <EzGraph.h>

#include "config.h"
#include "layout.h"
#include "title.h"
#include "draw.h"
#include "title_draw.h"
#include "font.h"
//#include "obj_draw.h"
//#include "anime.h"

#include "xpm/title.xpm"
//#include "xpm/pointer.xpm"
#include "xpm/chee_r16.xpm"


static EzImage title_img;
static EzImage pointer_img;

static char *title_str = "ぞ　う　ご　は　ん";
static font_id_t *title_fontseq;

static char *item_strs[ti_end] = {
	"げーむ",
    //	"せつめい",
//	"えでぃた",
//	"せってい",
	"おわる",
};

#define ITEM_NUM (sizeof(item_strs)/sizeof(char*))
static font_id_t **item_fontseqs;

void title_draw_init(void){
	int i;

    assert(ti_end == ITEM_NUM);

    title_img = EzReadXPM(title_xpm);
    pointer_img = EzReadXPM(chee_r16_xpm);
    //    pointer_img = EzReadXPM(pointer_xpm);
    //    printf("title:%p pointer:%p\n", title_img, pointer_img);
    title_fontseq = alloc_fontseq(title_str);
    item_fontseqs = alloc_fontseq_array(ITEM_NUM);
	for (i = 0 ; i < ITEM_NUM ; i++){
		item_fontseqs[i] = alloc_fontseq(item_strs[i]);
	}

}

void draw_title(void){
    int i;
    
    EzPutB((WIN_WIDTH-TITLE_WIDTH)/2, 24, title_img);
	for (i = 0 ; i < ITEM_NUM ; i++){
        draw_fontseq((WIN_WIDTH-16*4)/2, 320+i*LINESKIP, item_fontseqs[i]);
	}
    EzPutB((WIN_WIDTH-16*6)/2,
           320+get_title_cursor_pos()*LINESKIP,
           pointer_img);
    draw_fontseq((WIN_WIDTH-16*9)/2, 228, title_fontseq);
	EzShowBuffer();
}




